import React, { Component } from 'react'
import ReactDOM from 'react-dom'
//	Ref: https://stackoverflow.com/a/43470639/6637365
import { HashRouter, Route, Link } from 'react-router-dom'

import Validation from './FormWithValidation'
import FormStore from './FormWithStore'
import Undo from './FormWithUndo'
import List from './FormWithList'
import LargeTable from './LargeTable'
import styles from './index.icss'

// TODO: the examples now need improving due to material-ui changes
// the only changes done so far is to just make it work, not to look any good

class App extends Component {
	render() {
		return (
			<div>
				<div className={styles.topmenu}>
					<Link className={styles.link} to={'/validation'}>Validation example</Link>
					<Link className={styles.link} to={'/store'}>Store in form example</Link>
					<Link className={styles.link} to={'/undo'}>Undo/Redo example</Link>
					<Link className={styles.link} to={'/list'}>List example</Link>
					<Link className={styles.link} to={'/table'}>Large table example</Link>
				</div>

				<Route exact path="/validation" component={Validation} />
				<Route exact path="/store" component={FormStore} />
				<Route exact path="/undo" component={Undo} />
				<Route exact path="/list" component={List} />
				<Route exact path="/table" component={LargeTable} />
			</div>
		)
	}
}


ReactDOM.render(
	<HashRouter>
		<App />
	</HashRouter>,
	global.document.getElementById('app')
)
